"use strict";

Object.defineProperty(exports, "__esModule", {
    value: !0
}), exports.PolygonSemanticMark = void 0;

const semantic_mark_1 = require("./semantic-mark"), vgrammar_util_1 = require("@visactor/vgrammar-util"), enums_1 = require("./enums"), vgrammar_core_1 = require("@visactor/vgrammar-core");

class PolygonSemanticMark extends semantic_mark_1.SemanticMark {
    constructor(id) {
        super(enums_1.PlotMakType.polygon, id);
    }
    setMarkType() {
        return vgrammar_core_1.GrammarMarkType.polygon;
    }
    parseScaleOfEncodeX(option) {
        const res = super.parseScaleOfEncodeX(option);
        return res.type = "point", res;
    }
    parseScaleByEncode(channel, option) {
        return this.parseScaleOfCommonEncode(channel, option);
    }
    convertMarkEncode(encode) {
        var _a, _b, _c, _d, _e, _f, _g, _h;
        const markEncoder = this.convertSimpleMarkEncode(encode), scaleXId = this.getScaleId("x"), scaleYId = this.getScaleId("y"), res = {};
        if ((null === (_b = null === (_a = markEncoder.x) || void 0 === _a ? void 0 : _a.field) || void 0 === _b ? void 0 : _b.length) && (null === (_d = null === (_c = markEncoder.y) || void 0 === _c ? void 0 : _c.field) || void 0 === _d ? void 0 : _d.length)) {
            const xAccessors = markEncoder.x.field.map((f => (0, vgrammar_util_1.field)(f))), yAccessors = markEncoder.y.field.map((f => (0, 
            vgrammar_util_1.field)(f)));
            res.points = (datum, el, params) => {
                const scaleX = params[scaleXId], scaleY = params[scaleYId], minLen = Math.min(xAccessors.length, yAccessors.length), points = [];
                for (let i = 0; i < minLen; i++) points.push({
                    x: scaleX.scale(xAccessors[i](datum)),
                    y: scaleY.scale(yAccessors[i](datum))
                });
                return points;
            };
        }
        return markEncoder.stroke && (res.stroke = markEncoder.stroke), markEncoder.color || markEncoder.group ? res.fill = null !== (_e = markEncoder.color) && void 0 !== _e ? _e : markEncoder.group : res.fill = null !== (_g = null === (_f = this.spec.style) || void 0 === _f ? void 0 : _f.fill) && void 0 !== _g ? _g : null === (_h = this.getPalette()) || void 0 === _h ? void 0 : _h[0], 
        res;
    }
}

exports.PolygonSemanticMark = PolygonSemanticMark, PolygonSemanticMark.type = enums_1.PlotMakType.polygon;
//# sourceMappingURL=polygon.js.map